Merge pull request #496 from nicolas-raoul/unit-test-for-issue2907
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         finalizer-wait.cs       \
364         critical-finalizers.cs  \
365         appdomain-thread-abort.cs \
366         xdomain-threads.cs      \
367         w32message.cs   \
368         bug-544446.cs   \
369         gc-altstack.cs  \
370         large-gc-bitmap.cs      \
371         bug-561239.cs   \
372         bug-562150.cs   \
373         bug-575941.cs   \
374         bug-599469.cs   \
375         bug-389886-3.cs \
376         monitor.cs      \
377         dynamic-method-resurrection.cs  \
378         bug-666008.cs   \
379         bug-685908.cs   \
380         sgen-long-vtype.cs      \
381         delegate-invoke.cs      \
382         bug-696593.cs   \
383         bug-705140.cs   \
384         bug-1147.cs     \
385         mono-path.cs    \
386         bug-bxc-795.cs  \
387         bug-3903.cs     \
388         async-with-cb-throws.cs \
389         appdomain-unload-doesnot-raise-pending-events.cs        \
390         bug-6148.cs
391
392 TEST_CS_SRC_DIST=       \
393         $(BASE_TEST_CS_SRC)     \
394         async-exc-compilation.cs \
395         filter-stack.cs \
396         finally_guard.cs
397
398 TEST_CS_SRC_GEN = \
399         runtime-invoke.gen.cs \
400         imt_big_iface_test.cs
401
402 if AMD64
403 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
404 # #651684
405 PLATFORM_DISABLED_TESTS = finally_guard.exe
406 else
407 if X86
408 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
409 else
410 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
411 endif
412 endif
413
414 if IA64
415 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
416 # bug #319249
417 PLATFORM_DISABLED_TESTS=exception17.exe
418 PLATFORM_DISABLED_TESTS+=winx64structs.exe
419 endif
420
421 if X86
422
423 if HOST_WIN32
424 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
425 endif
426
427 endif
428
429 if POWERPC
430 # bug #71274
431 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
432 endif
433
434 if ARM
435 PLATFORM_DISABLED_TESTS=filter-stack.exe
436 endif
437
438 if MIPS
439 # monitor.exe is racy
440 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
441 endif
442
443 if S390x
444 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
445 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
446 endif
447
448 # The two finalizer tests only work under sgen
449 # gc-altstack.exe fails under boehm because it has no support for altstack
450 # bug-459094.exe creates an extremely deep directory tree
451 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
452 # reverted.
453 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
454 DISABLED_TESTS=                 \
455         delegate-async-exception.exe    \
456         bug-348522.2.exe        \
457         finalizer-wait.exe      \
458         critical-finalizers.exe \
459         gc-altstack.exe \
460         bug-459094.exe \
461         delegate-invoke.exe \
462         generic_type_definition.2.exe \
463         $(PLATFORM_DISABLED_TESTS)
464
465 DISABLED_TESTS_WRENCH=  \
466         $(DISABLED_TESTS)       \
467         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
468         main-returns-background-resetabort.exe \
469         main-returns-background-abort-resetabort.exe    \
470         main-returns-background.exe     \
471         thread6.exe     \
472         assemblyresolve_event3.exe \
473         delegate2.exe   \
474         finally_guard.exe       \
475         finalizer-abort.exe     \
476         finalizer-exit.exe      \
477         finalizer-thread.exe \
478         appdomain-async-invoke.exe
479
480 AOT_DISABLED_TESTS=constraints-load.exe
481
482 # These only compile with MS CSC
483 TEST_CSC_SRC=                   \
484         vararg.cs
485
486 TEST_IL_SRC=                    \
487         field-access.il         \
488         method-access.il        \
489         ldftn-access.il         \
490         cpblkTest.il            \
491         vbinterface.il          \
492         calliTest.il            \
493         ckfiniteTest.il         \
494         fault-handler.il                \
495         locallocTest.il         \
496         initblkTest.il          \
497         qt-instance.il          \
498         vararg.il               \
499         bug-29859.il            \
500         bug-78549.il            \
501         static-fields-nonconst.il       \
502         reload-at-bb-end.il     \
503         test-enum-indstoreil.il \
504         filter-bug.il           \
505         even-odd.il             \
506         bug-82022.il    \
507         vt-sync-method.il       \
508         enum_types.il   \
509         invalid-token.il        \
510         call_missing_method.il  \
511         call_missing_class.il   \
512         ldfld_missing_field.il  \
513         ldfld_missing_class.il  \
514         find-method.2.il        \
515         bug-79215.2.il  \
516         bug-79956.2.il  \
517         bug-327438.2.il \
518         bug-387274.2.il \
519         bug-426309.2.il \
520         ldtoken_with_byref_typespec.2.il \
521         resolve_method_bug.2.il \
522         resolve_field_bug.2.il \
523         resolve_type_bug.2.il   \
524         generics-sharing-other-exc.2.il \
525         generic-ldobj.2.il      \
526         generic-mkrefany.2.il   \
527         generic-refanyval.2.il  \
528         generic-ldtoken.2.il    \
529         generic-ldtoken-method.2.il     \
530         generic-ldtoken-field.2.il      \
531         generic-tailcall.2.il   \
532         generic-tailcall2.2.il  \
533         generic-array-exc.2.il  \
534         generic-valuetype-newobj2.2.il  \
535         generic-valuetype-newobj.2.il   \
536         generic-constrained.2.il        \
537         generic-type-load-exception.2.il        \
538         bug-81466.il    \
539         bug457574.il    \
540         bug445361.il    \
541         bug-463303.il   \
542         bug469742.2.il  \
543         bug-528055.il   \
544         constraints-load.il     \
545         array_load_exception.il \
546         bug-481403.il   \
547         interface-with-static-method.il \
548         bug-515884.il   \
549         bug-633291.il   \
550         delegate-with-null-target.il    \
551         bug-318677.il   \
552         gsharing-valuetype-layout.il    \
553         invalid_generic_instantiation.il
554
555
556 # pre-requisite test sources: files that are not test themselves
557 # but that need to be compiled
558 PREREQ_IL_SRC=event-il.il module-cctor.il
559 PREREQ_CS_SRC=
560 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
561 PREREQ_CS_DLL_SRC=
562
563 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
564 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
565 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
566 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
567 TESTBS=$(BENCHSRC:.cs=.exe)
568 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
569
570 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
571         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
572
573 %.exe: %.il
574         $(ILASM) -out:$@ $<
575
576 %.exe: %.cs TestDriver.dll
577         $(MCS) -r:TestDriver.dll -out:$@ $<
578
579 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
580 if POWERPC
581 test_platform:
582 else
583 # Can't use mkbundle on win32 since there is no static build there
584 # Can't run test-unhandled-exception on Windows because of all the debug popups...
585 if HOST_WIN32
586 test_platform:
587 else
588 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
589 #test_platform: testbundle test-iomap-regression
590 test_platform:  test-iomap-regression
591 endif
592 endif
593
594 if X86
595 if HOST_WIN32
596 else
597 test_platform: test-eglib-remap
598 endif
599 endif
600
601 # Target to precompile the test executables
602 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
603
604 #
605 # Test that no symbols are missed in eglib-remap.h
606 #
607 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
608 test-eglib-remap:
609         @echo "Testing eglib remap..."
610         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
611
612 #
613 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
614 # code that checks that the table is properly sorted
615 #
616 test-messages: w32message.exe
617         > test_messages.zero
618         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
619
620 if MOONLIGHT
621 test_2_1 : test-coreclr-security
622 else
623 test_2_1 :
624 endif
625
626 if AMD64
627 test-sgen : sgen-tests
628 else
629 if X86
630 test-sgen : sgen-tests
631 else
632 if ARM
633 test-sgen : sgen-tests
634 else
635 if S390x
636 test-sgen : sgen-regular-tests
637 endif
638 endif
639 endif
640 endif
641
642 test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test-messages
643 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
644
645 # Remove empty .stdout and .stderr files for wrench
646 rm-empty-logs:
647         @echo "Removing empty logs..."
648         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
649
650 assemblyresolve/test/asm.dll:
651         $(MAKE) -C assemblyresolve prereq
652
653 TestDriver.dll:
654         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
655
656 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
657         @failed=0; \
658         passed=0; \
659         for i in $(TESTSI_CS); do       \
660                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
661                 then \
662                         passed=`expr $${passed} + 1`; \
663                 else \
664                         if [ $$? = 2 ]; then break; fi; \
665                         failed=`expr $${failed} + 1`; \
666                 fi \
667         done; \
668         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
669
670 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
671         @failed=0; \
672         passed=0; \
673         for i in $(TESTSI_IL); do       \
674                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
675                 then \
676                         passed=`expr $${passed} + 1`; \
677                 else \
678                         if [ $$? = 2 ]; then break; fi; \
679                         failed=`expr $${failed} + 1`; \
680                 fi \
681         done; \
682         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
683
684 testb: $(TEST_PROG) $(TESTBS)
685         for i in $(TESTBS); do  \
686                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
687         done
688
689 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
690         @failed=0; \
691         passed=0; \
692         failed_tests="";\
693         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
694                 rm -f $${i}.so; \
695                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
696                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' $(RUNTIME_ARGS); \
697                 then \
698                         passed=`expr $${passed} + 1`; \
699                 else \
700                         if [ $$? = 2 ]; then break; fi; \
701                         failed=`expr $${failed} + 1`; \
702                         failed_tests="$${failed_tests} $$i"; \
703                 fi \
704         done; \
705         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
706         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
707           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
708
709 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
710         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
711
712 testjit-wrench:
713         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
714
715 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
716         @failed=0; \
717         passed=0; \
718         failed_tests="";\
719         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
720                 rm -f $${i}.so; \
721                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
722                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
723                 then \
724                         passed=`expr $${passed} + 1`; \
725                 else \
726                         if [ $$? = 2 ]; then break; fi; \
727                         failed=`expr $${failed} + 1`; \
728                         failed_tests="$${failed_tests} $$i"; \
729                 fi \
730         done; \
731         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
732         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
733           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
734
735 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
736         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
737
738 testjit:
739         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
740
741 testaot:
742         @$(MAKE) AOT=1 runtest
743
744 testtrace:
745         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
746
747 testinterp:
748         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
749
750 testjitspeed: $(JITTEST_PROG) $(TESTBS)
751         for i in $(TESTBS); do  \
752                 echo $$i;       \
753                 time $(JITTEST_PROG) $$i;       \
754         done
755
756 test-iomap-regression: exists.cs
757         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
758         @echo "Testing exists.exe..."
759         @MONO_IOMAP=all $(RUNTIME) exists.exe
760
761 stresstest: $(STRESS_TESTS)
762         @failed=0; \
763         passed=0; \
764         failed_tests="";\
765         for i in $(STRESS_TESTS); do    \
766                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
767                 then \
768                         passed=`expr $${passed} + 1`; \
769                 else \
770                         if [ $$? = 2 ]; then break; fi; \
771                         failed=`expr $${failed} + 1`; \
772                         failed_tests="$${failed_tests} $$i"; \
773                 fi \
774         done; \
775         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
776         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
777           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
778
779 testbundle: console.exe
780         @echo "Testing mkbundle..."
781         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
782         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
783         @- rm -rf a.out
784
785 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
786 test-type-load: TestDriver.dll
787         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
788         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
789         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
790         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
791         @echo "Testing load-exception.exe..."
792         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
793
794
795 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs
796
797 SGEN_TESTS =    \
798         sgen-descriptors.exe    \
799         sgen-gshared-vtype.exe  \
800         sgen-domain-unload.exe
801
802 sgen-regular-tests: $(SGEN_TESTS)
803         @for fn in $+ ; do      \
804                 echo "Testing $$fn ...";        \
805                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.1.stdout 2> $$fn.1.stderr || exit 1;     \
806                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.2.stdout 2> $$fn.2.stderr || exit 1;     \
807                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.3.stdout 2> $$fn.3.stderr || exit 1; \
808                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.4.stdout 2> $$fn.4.stderr || exit 1; \
809                 MONO_GC_PARAMS=major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.5.stdout 2> $$fn.5.stderr || exit 1;        \
810                 MONO_GC_PARAMS=minor=split,major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.6.stdout 2> $$fn.6.stderr || exit 1;    \
811                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.7.stdout 2> $$fn.7.stderr || exit 1;  \
812                 MONO_GC_PARAMS=minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.8.stdout 2> $$fn.8.stderr || exit 1;  \
813         done
814
815
816 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
817         @echo "Testing sgen-bridge.exe ...";    \
818         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.1.stdout 2> sgen-bridge.exe.1.stderr || exit 1;  \
819         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.2.stdout 2> sgen-bridge.exe.2.stderr || exit 1;      \
820         echo "Testing sgen-bridge-major-fragmentation.exe ..."; \
821         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.1.stdout 2> sgen-bridge-major-fragmentation.exe.1.stderr || exit 1;      \
822         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.2.stdout 2> sgen-bridge-major-fragmentation.exe.2.stderr || exit 1;
823
824
825 # Generated tests for runtime invoke
826 EXTRA_DIST += gen-runtime-invoke.cs
827 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
828         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
829         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
830
831 EXTRA_DIST += make-imt-test.cs
832 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
833         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
834         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
835
836 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
837 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
838         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
839 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
840         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
841
842 EXTRA_DIST += unhandled-exception-base-configuration.config
843 EXTRA_DIST += unhandled-exception-legacy-configuration.config
844 EXTRA_DIST += appdomain-unload.exe.config
845 EXTRA_DIST += unhandled-exception-test-case.2.cs
846 EXTRA_DIST += unhandled-exception-test-runner.2.cs
847 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
848         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
849 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
850         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
851 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
852         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
853 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
854         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
855         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
856         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
857         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
858 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
859         $(MCS) /debug unhandled-exception-test-case.1.cs
860 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
861         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
862 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
863         $(MCS) /debug unhandled-exception-test-case.2.cs
864 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
865         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
866 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
867         $(MCS) /debug unhandled-exception-test-runner.2.cs
868
869 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
870         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
871
872 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
873 bug-80307.exe: $(srcdir)/bug-80307.cs
874         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
875         cd $(top_builddir)/runtime && $(MAKE) test-support-files
876
877 EXTRA_DIST += bug-81673-interface.cs
878 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
879         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
880         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
881         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
882
883 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
884 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
885         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
886         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
887         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
888         rm -f bug-81691-a.dll
889 bug-81691.exe: bug-81691-b.dll
890
891 EXTRA_DIST += bug-81466-lib.il
892 bug-81466-lib.dll: bug-81466-lib.il
893         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
894 bug-81466.exe: bug-81466.il bug-81466-lib.dll
895         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
896
897 EXTRA_DIST += bug-324535-il.il
898 bug-324535-il.dll : bug-324535-il.il
899         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
900 bug-324535.exe : bug-324535.cs bug-324535-il.dll
901         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
902
903 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
904 custom-modifiers-lib.dll: custom-modifiers-lib.il
905         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
906 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
907         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
908
909 EXTRA_DIST += bug-382986-lib.cs
910 bug-382986-lib.dll: bug-382986-lib.cs
911         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
912 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
913         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
914
915 EXTRA_DIST += coreclr-security.cs
916
917 if MOONLIGHT
918 coreclr-security.exe : coreclr-security.cs
919         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
920
921 test-coreclr-security : coreclr-security.exe
922         @echo "Testing coreclr-security.exe..."
923         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
924 endif
925
926 EXTRA_DIST += generic-unboxing.2.il
927 generic-unboxing.2.dll : generic-unboxing.2.il
928         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
929
930 EXTRA_DIST += generic-boxing.2.il
931 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
932         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
933
934 EXTRA_DIST += generic-unbox.2.cs
935 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
936         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
937
938 EXTRA_DIST += generic-box.2.cs
939 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
940         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
941
942 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
943 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
944         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
945 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
946         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
947
948 bug-3903.exe: bug-3903.cs
949         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
950
951 gshared: test-generic-sharing
952
953 gshared-aot:
954         @$(MAKE) AOT=1 gshared
955
956 GSHARED_TESTS = \
957                 generics-sharing.2.exe shared-generic-methods.2.exe     \
958                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
959                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
960                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
961                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
962                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
963                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
964                 generic-virtual.2.exe generic-tailcall.2.exe                    \
965                 generic-interface-methods.2.exe generic-array-type.2.exe        \
966                 generic-method-patching.2.exe generic-static-methods.2.exe      \
967                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
968                 generic-array-exc.2.exe generic-special.2.exe                   \
969                 generic-exceptions.2.exe generic-delegate2.2.exe                \
970                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
971                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
972                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
973                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
974                 generic-constrained.2.exe bug-431413.2.exe                      \
975                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
976                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
977                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
978                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
979                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
980                 bug-479763.2.exe generic-xdomain.2.exe                          \
981                 generic-type-load-exception.2.exe bug-616463.exe        \
982                 bug-1147.exe
983
984 test-generic-sharing-normal: $(GSHARED_TESTS)
985         @for fn in $+ ; do      \
986                 echo "Testing $$fn ...";        \
987                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
988                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
989                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
990                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
991                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
992         done
993
994 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
995         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
996
997 test-generic-sharing:
998         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
999
1000 EXTRA_DIST += async-exceptions.cs
1001 async-exceptions.exe : async-exceptions.cs
1002         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1003 test-async-exceptions : async-exceptions.exe
1004         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1005         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1006
1007 EXTRA_DIST += modules.cs modules-m1.cs
1008 modules-m1.netmodule: modules-m1.cs
1009         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1010 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1011         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1012
1013 # Useful if mono is compiled with --enable-shared=no
1014 patch-libtool:
1015         cp "../../libtool" .
1016         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1017         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1018         touch libtest.c
1019
1020 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1021 test-process-exit:
1022         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1023         @echo "Testing bug-438454.exe..."
1024         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1025         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1026
1027 OOM_TESTS =     \
1028         gc-oom-handling.exe     \
1029         gc-oom-handling2.exe
1030
1031
1032 test-oom: $(OOM_TESTS)
1033         @for fn in $+ ; do      \
1034                 echo "Testing $$fn ...";        \
1035                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1036                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1037                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1038         done
1039
1040
1041 noinst_LTLIBRARIES = libtest.la
1042
1043 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1044
1045 if HOST_WIN32
1046 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1047 # This shows up when compiling mono_test_marshal_delegate ()
1048 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1049 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1050 # can't find them. So we use --kill-at to remove the @ suffix as well.
1051 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1052 else
1053 libtest_la_LDFLAGS = -rpath `pwd`
1054 endif
1055 libtest_la_SOURCES = libtest.c
1056 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1057
1058 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat